<script setup>
import {ARROW_LEFT, ARROW_RIGHT} from '~/components/Slider/Leaf.vue';
import { theme } from '/app.vue';

import {showDialogSignalerEvent} from "~/components/dialog/box.vue";
import gsap from 'gsap';

  definePageMeta({
    layout: 'detail',
    name: 'Détail de l\'événement',
    breadcrumbs: [{name: "Mode galerie",fullPath:"/gallery"},{name: "Détail de l\'événement",fullPath:"#"}],
    relaod: false
  });

const config = useRuntimeConfig()
const route = useRoute();
// data principale
const dateSlider_actuel =await useFetch(`${config.public.apiUrl}/dates/${route.params.uid}`);
dateSlider_actuel.value=dateSlider_actuel.data.value;

const bgCategorieClass=computed (()=>{
  if (theme.value && theme.value=="dark") {
    return  "bg-las-card-event-catg-dark ";
  }

  return "bg-las-card-event-catg  ";
});

// memoire des event visité
const memoireEventDate =  new Map();
const dateSlider_Stocker = ref({});
Object.assign(dateSlider_Stocker.value,dateSlider_actuel.value);
memoireEventDate.set(dateSlider_Stocker.value.uid,dateSlider_Stocker);

// data de navigation du carroussel
const dateSlider_left = ref ({});
await chargerEventDate (dateSlider_actuel.value.neighbours.previous_event,dateSlider_left);
const visibilityArrowLeft = computed (()=>{ return dateSlider_actuel.value.neighbours.previous_event!=null})
const dateSlider_right = ref ({});
await  chargerEventDate (dateSlider_actuel.value.neighbours.next_event,dateSlider_right);
const visibilityArrowRight = computed (()=>{ return dateSlider_actuel.value.neighbours.next_event!=null})

// information pour le menu contextuel
const urlActual= computed (()=>{return "http://localhost:3000/gallery/"+dateSlider_actuel.value.uid; });
const mailTitle = computed (()=>{return dateSlider_actuel.value.name?dateSlider_actuel.value.name:dateSlider_actuel.value.event.name; });

// data des "smallLeaf" du bas de page
const dateData = computed (()=>{ return reOrderByDatesUID(dateSlider_actuel.value)});
   
const indexSmallLeaf = ref (0);

// navigation du carroussel
async function onArrow (event) {
    if (event===ARROW_LEFT) {
      Object.assign(dateSlider_right.value,dateSlider_actuel.value);
      Object.assign(dateSlider_actuel.value,dateSlider_left.value);
     chargerEventDate (dateSlider_actuel.value.neighbours.previous_event,dateSlider_left)
    }else if (event===ARROW_RIGHT){
      Object.assign(dateSlider_left.value,dateSlider_actuel.value);
      Object.assign(dateSlider_actuel.value,dateSlider_right.value);
      chargerEventDate (dateSlider_actuel.value.neighbours.next_event,dateSlider_right)
    }

    setIndexSmallLeaf (0);
}

//outils internes
async function chargerEventDate (id,eventDate){
    if (id){
      if (memoireEventDate.has (id)) {
        Object.assign(eventDate.value,memoireEventDate.get(id).value);
      }else{
        await useFetch(`${config.public.apiUrl}/dates/${id}`).then(
          (d)=>{ 
            //eventDate.value=d.data.value;
            Object.assign(eventDate.value,d.data.value);
            memoireEventDate.set(id,d.data);
          }
          ).catch ((e)=>{console.log ("ECHEC LOAD '"+id+"' dans onMounted="+e);});
      }
    }
    else{
      eventDate=null;
    }
}

function onClickSmallLeaf (uid) {
     reloadAllData (uid);
     window.scrollTo({top: 0, behavior: 'smooth'});
     setIndexSmallLeaf (0);
}

async function reloadAllData (uid) {
    var tmpData=ref ({});
    await chargerEventDate (uid,tmpData);
    Object.assign(dateSlider_actuel.value,tmpData.value);
    await chargerEventDate (dateSlider_actuel.value.neighbours.previous_event,tmpData);
    Object.assign(dateSlider_left.value,tmpData.value);
    await chargerEventDate (dateSlider_actuel.value.neighbours.next_event,tmpData);  
    Object.assign(dateSlider_right.value,tmpData.value);
}

function onSmallLeafArrow (event, nbLeaf){
  let value = indexSmallLeaf.value;
  if (event==ARROW_LEFT){
    if (value > 0)
      value=value-1;
  }else if (event==ARROW_RIGHT){
    if (value+4 < nbLeaf)
      value=value+1;
  }
  changeTitle ();
  setIndexSmallLeaf (value);
}

function setIndexSmallLeaf (value){
    //memorisation du nouvel index
    indexSmallLeaf.value = value;
    //calcul de l'affichage des smallLeaf
    document.getElementById("smallLeafPanel").scrollLeft=value*262;
}

function changeTitle () {
  const timeLine = gsap.timeline();

  // on effasse le titre
  timeLine.duration (0.5);
  timeLine.to ("#titlePage",{scale: 0, opacity: 0},0);

  // PUIS on réaffiche le titre
  timeLine.duration (0.5);
  timeLine.to ("#titlePage",{scale: 1, opacity: 1},0.5);
}

function signaler () {
  showDialogSignalerEvent (dateSlider_actuel.value);
}
</script>

<template>
    <!-- bouton signaler-->
    <a @click="signaler()" >
      <div class="relative before:absolute before:right-36 before:top-0 before:opacity-0 before:content-['signaler'] before:bg-white before:text-black before:border before:border-slate-200 before:rounded-md before:p-1 before:z-50 hover:before:opacity-100" >
        <img src="/images/exclamation.svg" class="absolute right-40 top-8 mr-1 hover:cursor-pointer" width="30px" height="30px" alt="signaler" />
      </div>
    </a>

    <!-- menu contextuel -->
    <ContextMenuPartagerButton locationClass="absolute right-40 top-44" :url="urlActual" :mailtitle="mailTitle" :mailbody="urlActual" />

    <section id="debutPage" class="mx-auto w-[1440px] flex content-center justify-center">
      <aside class="flex flex-col w-[450px]">
        <!-- 1 image et une map -->
          <NuxtImg :src="dateSlider_actuel.value.event.thumbnail?dateSlider_actuel.value.event.thumbnail:'/images/default_img.svg'" sizes="100vw" />
          <!-- here goes a map, placeholder for now -->
          <img src="/images/carte.png" height="100vw" />
      </aside>

      <article class="relative w-[990px] text-left ml-8">
        <div class="w-full relative font-las">
          <DisplayTime :start_date="dateSlider_actuel.value.start_date" :end_date="dateSlider_actuel.value.end_date" :start_hour="dateSlider_actuel.value.start_hour" :end_hour="dateSlider_actuel.value.end_hour" mode="detail" />
          <span :class="bgCategorieClass+' w-[190px] h-[72px] text-center text-2xl text-las-orange  absolute left-[160px] z-1 bg-right-top flex justify-center items-center overflow-hidden line-clamp-2 bg-cover bg-cover ' ">{{ dateSlider_actuel.value.main_category.name }}</span>
        </div>
        <!-- slider events -->
          <div class="w-full relative overflow-hidden">
            <div class="text-las text-2xl flex flex-col justify-center text-center">
              <SliderLeaf :dateData="dateSlider_actuel.value" @arrow="onArrow" :url="urlActual" :vright="visibilityArrowRight" :vleft="visibilityArrowLeft" />
            </div>
          </div>
      </article>
    </section>

    <section v-if="dateSlider_actuel.value.associated_dates.length>1" class="mx-auto w-[1440px] flex content-center justify-center">
      <!-- partie texte festival -->
      <article class="relative w-full text-left ml-[150px]">
        <SectionTitle :title="dateSlider_actuel.value.event.name" hx="h1" align="left" />
        <p class="w-[1060px] text-base">
          {{ dateSlider_actuel.value.event.description }}
        </p>
      </article>
    </section>

    <SectionTitle title="Autres dates" hx="h1" :quoteRight="true" />

    <div class="z-0 relative mx-auto my-9 w-[1440px] h-[150px]">  
      <div class="z-10 absolute">
        <section class="relative mx-auto my-9 w-[1440px] h-[150px] flex content-center justify-center">
            <!-- slider du bas navigation `autres événements`-->

          <div id="smallLeafPanel" class="w-[1044px] h-full overflow-hidden">
            <ol :class="'flex flex-row space-x-3 w-[1440px]'">
              <li
                @click="onClickSmallLeaf(dateData[event - 1].id)"
                v-for="event in dateData.length"
                :key="event"
                class="relative font-las flex flex-col justify-content align-centerrelative w-[250px] h-[100px] bg-white rounded-2xl shadow-las cursor-pointer hover:shadow-shadow-las-dark"
              >
                <DisplaySmallLeaf :dateData="dateData[event - 1]" class="min-w-[250px] max-w-[250px] w-[250px]  text-las-orange" />
              </li>
            </ol>
          </div>
        </section>
      </div>

      <div class="z-20 absolute mx-auto my-[68px] w-[1440px] h-[0px] flex content-center justify-center">
      <IconsArrowLeft @click="onSmallLeafArrow (ARROW_LEFT,dateData.length)" />
      <div class=" w-[1020px] h-[0px]"></div>
      <IconsArrowRight @click="onSmallLeafArrow (ARROW_RIGHT,dateData.length)" />
      </div>

    </div>

</template> 

<style scoped>
</style>